/* -*- c++ -*-
   hardwire.h
   */

#ifndef __hardwire_h_
#define __hardwire_h_

#include <sys/types.h>
#include <list.h>

#include <agent.h>
#include <packet.h>
#include <scheduler.h>

#include <cmu-trace.h>
#include <priqueue.h>
#include <rtqueue.h>
#include <rttable.h>


class HARDWIRE;

#define HARDWIRE_HDR_LEN    64      // amount of space allocated in the pkt hdr
#define MAXNUM 200   // maximum node number


#define VERY_LARGE_INTERVAL 40000


/* =====================================================================
   The Routing Agent
   ===================================================================== */
class HARDWIRE: public Agent {
        friend class rt_entry;
 public:
        HARDWIRE(nsaddr_t id);

        void		recv(Packet *p, Handler *);

        /*
         * HDR offsets
         */
        int             off_HARDWIRE_;

 protected:
        int             command(int, const char *const *);
        int             initialized() { return index && target_; }

        /*
         * Route Table Management
         */
        void            rt_resolve(Packet *p);


        nsaddr_t        index;                  // IP Address of this node
//        int             seqno;                  // Sequence Number
//        int             bid;                    // Broadcast ID

        /*
         * Routing Table
         */
        int          routetable[MAXNUM];


        PriQueue        *ifqueue;

 	Trace           *logtarget;
	rtqueue         rqueue;

};

#endif /* __hardwire_h_ */
